<template>
       <q-btn class="button" dense round flat icon="notifications_none">
      <q-badge v-show="badgeNumber > 0" dense color="white" text-color="red" floating>
       {{badgeNumber}}
      </q-badge>
      <q-popup-proxy>
        <q-list >
     <q-item v-for="not in notifs"
            :key="not.kamerId"
            clickable
            @click="goToPatient(not)">
        <q-item-section top avatar>
          <q-avatar rounded>
            <img :src="'http://localhost:3000/images/'+ not.foto">
          </q-avatar>
        </q-item-section>

        <q-item-section>
          <q-item-label>{{not.name}}</q-item-label>
        </q-item-section>

        <q-item-section side v-show="!not.read">
         <q-icon color="red" name="fiber_manual_record"></q-icon>
        </q-item-section>
      </q-item>
    </q-list>
      </q-popup-proxy>
       </q-btn>
</template>

<style scoped>
.button {
margin-right: 15px
}
</style>

<script>
import KamerService from '../services/KamerService'
import PatientService from '../services/PatientService'
import Utils from '../utils'
import ErrorService from '../services/ErrorService'

var audio = new Audio(require('../assets/hollow.mp3'))
audio.muted = true
export default {
  name: 'Notification',
  data () {
    return {
      pollingNotif: null,
      pollingRooms: null,
      notifs: [],
      badgeNumber: 0
    }
  },
  methods: {
    goToPatient: function (obj) {
      obj.read = true
      this.notifications()
      this.$router.push({ path: obj.route })
    },
    // notificaties worden opgehaald met een getter uit de globale object
    notifications () {
      this.notifs = this.$store.getters['settings/notifications']
      this.badgeNumber = this.notifs.filter(read).length
    },
    // er wordt nu gefilterd op patienten die hulp nodig hebben in hun kamer. Indien er zijn worden ze als notificatie verstuurt zodat de verpleegkundigen weten wie er net heeft gedrukt op het knopje
    async getAllHulp () {
      try {
        let array = await this.kamerservice.getAllHulpKamer()
        if (array.length !== 0) {
          this.filterArray(array)
        }
      } catch (error) {
        ErrorService.showAlert('Laden notificaties mislukt')
      }
    },
    putNotificationInArray (notification) {
      this.$store.dispatch('settings/pushNotif', notification)
      this.notifications()
      audio.muted = false
      audio.play()
    },

    // hier wordt gecheckt of de patient al een notificatie heeft, indien wel wordt het niet weer toegevoegd, indien niet dan wordt er een notificatie object toegevoegd aan de array
    filterArray (array) {
      let notifs = this.$store.getters['settings/notifications']
      for (let index = 0; index < array.length; index++) {
        if (!Utils.containsObject(array[index], notifs)) {
          try {
            this.patientservice.getById(array[index].patient).then(patient => {
              let noti = {
                name: patient.naam + ' in Kamer ' + array[index].id + ' heeft hulp nodig',
                read: false,
                route: '/patient/' + array[index].patient,
                kamerId: array[index].id,
                foto: patient.foto
              }
              this.putNotificationInArray(noti)
            })
          } catch (error) {
            ErrorService.showAlert('Laden patiënt in notificatie mislukt')
          }
        }
      }
    }
  },
  created () {
    this.kamerservice = new KamerService()
    this.patientservice = new PatientService()
    this.setting = this.$store.getters['settings/settings']
    // er wordt aan polling gedaan om zo meldingen te ontvangen van patiënten
    this.pollingNotif = setInterval(this.notifications, 5000)
    this.pollingRooms = setInterval(this.getAllHulp, 15000)
  }
}
function read (value) {
  return value.read === false
}
</script>
